import json

def comparelist(list1, list2):
    matchnum = 0
    for item in list1:
        if item in list2:
            matchnum += 1
    return matchnum

pairid = 1

file_address = "D:/F/UnivSub/UNC/masterpaper/data/last.fm/"
file_nameR = "toptrackfilter100info_tag.json"
file_nameW = "cotracks_norm_0321.json"

fp = open(file_address + file_nameR, "r")
s = fp.read()
j = json.loads(s)

toptracklist = [] + j

cotracklist = []
track_already = []

aaa = 0
for track in toptracklist:
    track_already.append(track['id'])

    for tracki in toptracklist:
        if tracki['id'] in track_already:
            continue
        else:
            newpair = {}
            newpair['pairid'] = pairid
            newpair['id1'] = track['id']
            newpair['id2'] = tracki['id']
            newpair['cooccurcount'] = comparelist(track['userlist'], tracki['userlist'])

            if track['artist'] == tracki['artist']:
                newpair['artist'] = 1
            else:
                newpair['artist'] = 0
            newpair['artist_era'] = comparelist(track['artist_era'], tracki['artist_era'])
            newpair['artist_origin'] = comparelist(track['artist_origin'], tracki['artist_origin'])
            newpair['artist_type'] = comparelist(track['artist_type'], tracki['artist_type'])

            newpair['genre'] = comparelist(track['genre'], tracki['genre'])
            newpair['mood'] = comparelist(track['mood'], tracki['mood'])
            newpair['tempo'] = comparelist(track['tempo'], tracki['tempo'])
            if track['album_title'] == tracki['album_title']:
                newpair['album_title'] = 1
            else:
                newpair['album_title'] = 0
            newpair['album_year_d'] = abs(track['album_year'] - tracki['album_year'])
            newpair['album_year'] = (2 * track['album_year'] * tracki['album_year']) / (track['album_year'] + tracki['album_year'])

            newpair['listeners_d'] = abs(track['listeners'] - tracki['listeners'])
            newpair['listeners'] = (2 * track['listeners'] * tracki['listeners']) / (
            track['listeners'] + tracki['listeners'])
            newpair['playcount_d'] = abs(track['playcount'] - tracki['playcount'])
            newpair['playcount'] = (2 * track['playcount'] * tracki['playcount']) / (
            track['playcount'] + tracki['playcount'])

            # normalization for listeners and playcount by number of years the track releases
            if track['album_year'] == 2018:
                listeners_norm = track['listeners']
                playcount_norm = track['playcount']
            else:
                listeners_norm = track['listeners'] / (2018 - track['album_year'])
                playcount_norm = track['playcount'] / (2018 - track['album_year'])
            if tracki['album_year'] == 2018:
                listenersi_norm = tracki['listeners']
                playcounti_norm = tracki['playcount']
            else:
                listenersi_norm = tracki['listeners'] / (2018 - tracki['album_year'])
                playcounti_norm = tracki['playcount'] / (2018 - tracki['album_year'])
            newpair['listeners_norm_d'] = abs(listeners_norm - listenersi_norm)
            newpair['listeners_norm'] = (2 * listeners_norm * listenersi_norm) / (
                listeners_norm + listenersi_norm)
            newpair['playcount_norm_d'] = abs(playcount_norm - playcounti_norm)
            newpair['playcount_norm'] = (2 * playcount_norm * playcounti_norm) / (
                playcount_norm + playcounti_norm)

            newpair['toptags5'] = comparelist(track['toptags'][:5], tracki['toptags'][:5])
            newpair['toptags'] = comparelist(track['toptags'], tracki['toptags'])
            if (len(track['toptags'])==0) or (len(tracki['toptags'])==0):
                newpair['toptags_norm'] = newpair['toptags']
            else:
                avglength = (2 * len(track['toptags']) * len(tracki['toptags'])) / (
                len(track['toptags']) + len(tracki['toptags']))
                newpair['toptags_norm'] = newpair['toptags']/avglength

            cotracklist.append(newpair)
            print('Pair id: ', pairid)
            pairid += 1

    print('Track id: ', track['id'])
    aaa += 1

with open(file_address + file_nameW, 'w') as f:
    json.dump(cotracklist, f, sort_keys=True, indent=2)

print('Cooccur tracklist success')
